"""Game faction module"""

from locals import *

class Faction:

    faction_colors = {}
    faction_colors["black"] = FACTION_BLACK
    faction_colors["white"] = FACTION_WHITE
    faction_colors["red"] = FACTION_RED
    faction_colors["purple"] = FACTION_PURPLE
    faction_colors["yellow"] = FACTION_YELLOW
    faction_colors["unoccupied"] = FACTION_UNOCCUPIED
    faction_colors["observer"] = FACTION_UNOCCUPIED

    def __init__(self, faction_color = 'red', resources = MONEY_ZERO, leader_name = ''):
        self.faction_color = faction_color
        self.resources = resources
        self.leader_name = leader_name
        self.has_comm = False
        return

    def use_resources(self, cost):
        i = 0
        afford = True
        for c in cost:
            if (c > self.resources[i]):
                afford = False
            i += 1
        if afford:
            self.resources = (self.resources[0] - cost[0],
            self.resources[1] - cost[1], self.resources[2] - cost[2])
        return afford

    def add_resources(self, amount):
        self.resources = (self.resources[0] + amount[0],
        self.resources[1] + amount[1], self.resources[2] + amount[2])
        return
        
    def set_resources(self, amount):
        self.resources = (amount[0], amount[1], amount[2])
        return

    def get_color(self):
        return self.faction_color

    def get_color_rgb(self):
        return Faction.faction_colors[self.faction_color]

    def get_resources(self):
        return self.resources

    def set_leader_name(self, leader_name):
        self.leader_name = leader_name
        return

    def get_leader_name(self):
        return self.leader_name

    def has_commander(self):
        if self.has_comm:
            return True
        else:
            self.has_comm = True
            return False