from locals import *

from mapobject import MapObject

from util import render_image, render_text

class Shrine(MapObject):

    def __init__(self, x, y, owner, shrine_type):
        MapObject.__init__(self, x, y, owner)
        self.shrine_type = shrine_type
        self.object_name = 'shrine_' + self.shrine_type
        return
        
    def render(self, screen, offset_x = 0, offset_y = 0):
        return MapObject.render(self, screen, offset_x, offset_y, \
        BUILDING_EMBLEM_POS)
        
    def produce_resources(self):
        res = MONEY_ZERO
        if self.shrine_type == 'rock':
            res = (SHRINE_PRODUCTION, 0, 0)
        elif self.shrine_type == 'paper':
            res = (0, SHRINE_PRODUCTION, 0)
        elif self.shrine_type == 'scissors':
            res = (0, 0, SHRINE_PRODUCTION)
        return res

    def render_infobox(self, screen, level):
        self.render_infobox_bg(screen, 0, 'Shrine owned by ' + self.owner)

        head = render_text('Produces 10      per round', 10)
        head_coords = (GUI_INFOBOX_COORDS[0] + 8, GUI_INFOBOX_COORDS[1] + 60)
        screen.blit(head, head_coords)

        head = render_text('Conquer by occupying', 10)
        head_coords = (GUI_INFOBOX_COORDS[0] + 8, GUI_INFOBOX_COORDS[1] + 78)
        screen.blit(head, head_coords)

        head = render_text('at the end of the turn', 10)
        head_coords = (GUI_INFOBOX_COORDS[0] + 8, GUI_INFOBOX_COORDS[1] + 92)
        screen.blit(head, head_coords)

        render_image(screen, 'res_icon_' + self.shrine_type + '.png', \
        (GUI_INFOBOX_COORDS[0] + 77, GUI_INFOBOX_COORDS[1] + 62))
        return